"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.concurrency = exports.go = void 0;
const tslib_1 = require("tslib");
const Defer_1 = require("./Defer");
const go = (code) => { code().catch(() => { }); };
exports.go = go;
class Task extends Defer_1.Defer {
    constructor(code) {
        super();
        this.code = code;
    }
}
const concurrency = (limit) => {
    let count = 0;
    const queue = [];
    const loop = () => (0, tslib_1.__awaiter)(void 0, void 0, void 0, function* () {
        const task = queue.shift();
        if (!task)
            return;
        else
            count++;
        try {
            task.resolve(yield task.code());
        }
        catch (error) {
            task.reject(error);
        }
        finally {
            count--, queue.length && (0, exports.go)(loop);
        }
    });
    return (code) => (0, tslib_1.__awaiter)(void 0, void 0, void 0, function* () {
        const task = new Task(code);
        queue.push(task);
        if (count < limit)
            (0, exports.go)(loop);
        return task.promise;
    });
};
exports.concurrency = concurrency;
